searchNodes=[{"doc":"Implementation of an Ueberauth Strategy for WorkOS Single Sign-On Configuration This provider supports the following configuration: api_key : ( Required ) WorkOS API key, which also acts as the OAuth client secret. This key is environment-specific and may be supplied using runtime configuration. client_id : ( Required ) OAuth client ID obtained from WorkOS. This ID is environment-specific and may be supplied using runtime configuration. callback_url : Redirect URI to send users for the callback phase. This URL must be allowed in the WorkOS configuration for the environment matching the Client ID. Defaults to a callback URL calculated using the endpoint host and provider name. Example configuration: config :ueberauth , Ueberauth , providers : [ workos : { Ueberauth.Strategy.WorkOS , [ api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) ] } ] Alternatively, you may configure the strategy module directly: config :ueberauth , Ueberauth.Strategy.WorkOS , api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) Connection Selector In addition to the configuration mentioned above, the request phase also accepts several params allowing the client to specify details of the login process. One of these is the Connection Selector . The WorkOS documentation states: To indicate the connection to use for authentication, use one of the following connection selectors: connection, organization, or provider. These connection selectors are mutually exclusive, and exactly one must be provided. Therefore, the request phase must include exactly one of connection , organization , or provider in the incoming params. These may be provided directly by the client, or inserted before Ueberauth runs (before plug Ueberauth ) by a custom plug. If absent, the request will fail immediately. Additional Params WorkOS also provides the ability to give &quot;hints&quot; about the domain or login. These hints may also be provided by the client or another plug using connection params: domain_hint : According to WorkOS: Can be used to pre-fill the domain field when initiating authentication with Microsoft OAuth, or with a GoogleSAML connection type. login_hint : According to WorkOS: Can be used to pre-fill the username/email address field of the IdP sign-in page for the user, if you know their username ahead of time. If you use an email address to determine the connection selector, then it is advisable to use the same email address as the login_hint .","ref":"Ueberauth.Strategy.WorkOS.html","title":"Ueberauth.Strategy.WorkOS","type":"module"},{"doc":"Callback implementation for Ueberauth.Strategy.default_options/0 .","ref":"Ueberauth.Strategy.WorkOS.html#default_options/0","title":"Ueberauth.Strategy.WorkOS.default_options/0","type":"function"},{"doc":"Implementation of an OAuth 2.0 strategy for WorkOS Single Sign-On Note This module is not intended to be called or configured directly. Please see Ueberauth.Strategy.WorkOS for all relevant configuration and documentation. Configuration This module uses the configuration defined in Ueberauth.Strategy.WorkOS . Unlike other Ueberauth strategies, there is no need to define application environment variables for this module.","ref":"Ueberauth.Strategy.WorkOS.OAuth.html","title":"Ueberauth.Strategy.WorkOS.OAuth","type":"module"},{"doc":"Get the authorization URL used during the request phase of Ueberauth","ref":"Ueberauth.Strategy.WorkOS.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.WorkOS.OAuth.authorize_url!/2","type":"function"},{"doc":"Construct a client for requests to the WorkOS API Options This function accepts the same options as OAuth2.Client.new/1 , including a redirect_uri . All options are collected and merged in this way: Options passed directly to this function have the highest precedence, overriding all others. Options configured with Ueberauth.Strategy.WorkOS have next-highest priority. There are default values for authorize_url , headers , site , and token_url . OAuth2 will use the same JSON serialization library as returned by Ueberauth.json_library/0 .","ref":"Ueberauth.Strategy.WorkOS.OAuth.html#client/1","title":"Ueberauth.Strategy.WorkOS.OAuth.client/1","type":"function"},{"doc":"Ueberauth strategy for integrating with WorkOS Single Sign-On","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"For detailed instructions, see Getting Started . Installation This package is not yet available on Hex.pm. In the meantime, you can install it directly from GitHub: def deps do [ { :ueberauth , &quot;~&gt; 0.10&quot; } , { :ueberauth_workos , github : &quot;codesandbox/ueberauth_workos&quot; } ] end Warning : This package is in early development, and not suitable for production use. Configuration This strategy requires two pieces of configuration. Because these values are likely to change between environments, and should be kept secret, we recommend using runtime configuration (for example, config/runtime.exs ). api_key : ( Required ) WorkOS API key, which also acts as the OAuth client secret. This key is environment-specific and must match the environment of the client_id .. client_id : ( Required ) OAuth client ID obtained from WorkOS. This ID is environment-specific and must match the environment of the api_key . The following configuration is optional: callback_url : Redirect URI to send users for the callback phase of OAuth. This URL must be allowed in the WorkOS configuration for the environment matching the client ID. By default, Ueberauth will construct a callback URL using the Phoenix endpoint host and the provider name. You may include these options directly in the provider configuration, if it occurs in the appropriate configuration file: config :ueberauth , Ueberauth , providers : [ workos : { Ueberauth.Strategy.WorkOS , [ api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) ] } ] Alternatively, you may configure the strategy module directly. This can be useful if you wish to place this in a separate configuration file: config :ueberauth , Ueberauth.Strategy.WorkOS , api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) Remember : It is recommended to use runtime configuration for the API key and client ID. Integration Much of the setup for this strategy will be familiar if you have integrated with other Ueberauth strategies. However, there is one additional step necessary: a redirect or plug that supplies connection information to the request phase. Unique to this strategy is the need for a Connection Selector during the request phase. For detailed instructions, see Getting Started .","ref":"readme.html#quick-start","title":"Overview - Quick Start","type":"extras"},{"doc":"Please see LICENSE for licensing details.","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"Much of the setup for this strategy will be familiar if you have integrated with other Ueberauth strategies. However, there is one additional step necessary: a redirect or plug that supplies connection information to the request phase.","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Note If you already have an API Key and Client ID from the WorkOS dashboard and SSO configuration, skip down to Installation . You can also check out the official documentation for WorkOS Single Sign-On. Prerequisites You must have a WorkOS account with Developer or Admin permissions. You must use the Developer or Staging environment in order to test with http:// or localhost redirect URLs. You must give billing information in order to use the Production environment. In order to configure this Ueberauth strategy, you will need two pieces of information from the WorkOS dashboard: API Key : On the dashboard , select API Keys in the left sidebar. Check that you are on the correct environment in the top-left. Copy the Secret key . Client ID : On the dashboard , select Configuration in the left sidebar. Check that you are on the correct environment in the top-left. Copy the Client ID . In addition, you must supply at least one Redirect URI on the same page where you copied the Client ID. This can be an http:// or localhost URL only if you are in the staging or development environment. Otherwise it must be a fully-qualified hostname that uses HTTPS. The entered URL should match exactly what you intend to use as the callback URL. For example: http://localhost:4000/auth/workos/callback https://example.com/auth/workos/callback","ref":"getting-started.html#set-up-with-workos","title":"Getting Started - Set Up with WorkOS","type":"extras"},{"doc":"With the two environment-specific secrets available, and the Redirect URI set up, you are ready to install and configure the strategy. Package Add ueberauth_workos as a dependency in mix.exs and run mix deps.get . This package is not yet available on Hex.pm. In the meantime, you can install it directly from GitHub: def deps do [ { :ueberauth , &quot;~&gt; 0.10&quot; } , { :ueberauth_workos , github : &quot;codesandbox/ueberauth_workos&quot; } ] end Provider Configuration Then add this library as a provider in your configuration for Ueberauth: config :ueberauth , Ueberauth , providers : [ workos : { Ueberauth.Strategy.WorkOS , [ ] } ] Unlike many other OAuth-based strategies, this library does not accept many options in the provider definition. The following configuration is optional: callback_url : Redirect URI to send users for the callback phase of OAuth. This URL must be allowed in the WorkOS configuration for the environment matching the client ID. By default, Ueberauth will construct a callback URL using the Phoenix endpoint host and the provider name. OAuth Configuration This strategy requires two pieces of configuration. Because these values are likely to change between environments, and should be kept secret, we recommend using runtime configuration (for example, config/runtime.exs ). api_key : ( Required ) WorkOS API key, which also acts as the OAuth client secret. This key is environment-specific and must match the environment of the client_id .. client_id : ( Required ) OAuth client ID obtained from WorkOS. This ID is environment-specific and must match the environment of the api_key . You may include these options directly in the provider configuration, if it occurs in the appropriate configuration file: config :ueberauth , Ueberauth , providers : [ workos : { Ueberauth.Strategy.WorkOS , [ api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) ] } ] Alternatively, you may configure the strategy module directly. This can be useful if you wish to place this in a separate configuration file: config :ueberauth , Ueberauth.Strategy.WorkOS , api_key : System . fetch_env! ( &quot;WORKOS_API_KEY&quot; ) , client_id : System . fetch_env! ( &quot;WORKOS_CLIENT_ID&quot; ) Remember : It is recommended to use runtime configuration for the API key and client ID.","ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"Much of the setup for this strategy will be familiar if you have integrated with other Ueberauth strategies. However, there is one additional step necessary: a redirect or plug that supplies connection information to the request phase. Plug Integration As with other Ueberauth providers, it is necessary to implement handlers for the callback phase. This usually includes adding Ueberauth as a plug in an authentication-related controller: defmodule MyAppWeb.AuthController do use MyAppWeb , :controller plug Ueberauth # ... end Then, implement handlers for success and failure cases during the callback phase: defmodule MyAppWeb.AuthController do # ... def callback ( %{ assigns : %{ ueberauth_failure : failure } } = conn , _params ) do message = Enum . map_join ( failure . errors , &quot;; &quot; , fn error -&gt; error . message end ) conn |&gt; put_flash ( :error , &quot;An error occurred during authentication: \#{ message } &quot; ) |&gt; redirect ( to : &quot;/&quot; ) end def callback ( %{ assigns : %{ ueberauth_auth : auth } } = conn , _params ) do case MyApp.Accounts . create_or_update_user ( auth ) do { :ok , user } -&gt; conn |&gt; put_flash ( :info , &quot;Successfully logged in&quot; ) |&gt; log_in_and_redirect_user ( user ) { :error , _changeset } -&gt; conn |&gt; put_flash ( :error , &quot;An error occurred while saving login&quot; ) |&gt; redirect ( to : &quot;/&quot; ) end end end Finally, ensure the relevant routes are available in the router: defmodule MyAppWeb.Router # ... scope &quot;/auth&quot; , UeberauthExampleWeb do pipe_through :browser get &quot;/:provider&quot; , AuthController , :request # Include this for requests with no scopes, or if you use other providers that require it. get &quot;/:provider/callback&quot; , AuthController , :callback # Include this for requests with any scopes (name and/or email). post &quot;/:provider/callback&quot; , AuthController , :callback end end For further assistance, check out the Ueberauth Example . Connection Selector Unique to this strategy is the need for a Connection Selector during the request phase. WorkOS describes it thusly: To indicate the connection to use for authentication, use one of the following connection selectors: connection, organization, or provider. These connection selectors are mutually exclusive, and exactly one must be provided. Therefore, the request phase must include exactly one of connection , organization , or provider in the incoming params. These may be provided directly by the client, or inserted before Ueberauth runs (before plug Ueberauth ) by a custom plug. If absent, the request will fail immediately. This is the point where you ask a user what organization they belong to before redirecting them to log in. Many applications do this using a discrete &quot;Sign In with SSO&quot; button and collecting the user's email address. Then, using the email address domain or an existing user record, the user is redirected to the request phase with the additional Connection Selector parameter. This library does not care which type of selector you use. Only one can be provided to WorkOS, so it will use the connection , organization , or provider in order. Example: Redirect to Request Phase In this example, we will use a separate endpoint to initiate the sign-in flow. We can conceptually think of this as a new first phase of the OAuth process called &quot;initialize&quot;. In our router, we will need a separate route: scope &quot;/auth&quot; , MyAppWeb do # ... get ( &quot;/workos/initialize&quot; , AuthController , :initialize ) get ( &quot;/:provider&quot; , AuthController , :request ) get ( &quot;/:provider/callback&quot; , AuthController , :callback ) end Then, in our controller, we accept the incoming user email and look up the corresponding user's WorkOS connection, organization, or provider. def initialize ( conn , %{ &quot;email&quot; =&gt; email } ) do case find_user_by_email ( email ) do { :ok , %{ workos_connection : connection_id } } -&gt; redirect ( to : &quot;/auth/workos?connection= \#{ connection_id } &quot; ) _else -&gt; conn |&gt; put_flash ( :error , &quot;SSO is not enabled for this email address&quot; ) |&gt; redirect ( to : &quot;/login&quot; ) end end Once redirected to the request phase endpoint with the connection selector param, Ueberauth will take over the interaction and return the user to your callback handler once complete. Example: Plug before Request Phase It is also possible to handle the email-to-connection-selector conversion using a Plug that runs before Ueberauth takes over the request phase. In order to accomplish this, the custom plug must run before plug Ueberauth for the request phase action. A full example is not included here, however it should end with a new param connection , organization , or provider present in the connection struct as it is handed off to Ueberauth. Additional Parameters You may optionally send the following parameters to the request phase in addition to the Connection Selector described above: domain_hint : According to WorkOS: Can be used to pre-fill the domain field when initiating authentication with Microsoft OAuth, or with a GoogleSAML connection type. login_hint : According to WorkOS: Can be used to pre-fill the username/email address field of the IdP sign-in page for the user, if you know their username ahead of time.","ref":"getting-started.html#integration","title":"Getting Started - Integration","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement by email . All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Hello there. Thank you for your interest in contributing to this project. Although the goals of this project are very simple, maintenance of any project takes effort. Reading and following the guidelines in this document is an act of kindness and respect for other contributors. With your help, we can address issues, make changes, and work together efficiently.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"There are many ways to contribute to this project: Users of the project can report issues and share new use-cases. Everyone can help improve documentation and support others in Discussions. Anyone can assist in the triage of bugs, identifying root causes, and proposing solutions. Please keep in mind the intended scope of this package: an Ueberauth strategy for integrating with WorkOS Single Sign-On.","ref":"contributing.html#ways-to-contribute","title":"Contributing - Ways to Contribute","type":"extras"},{"doc":"All contributions to this project must align with the code of conduct . Beyond that, we ask: Please be kind. Maintaining this project is not paid work. Please create an issue before embarking on major refactors or new features. Let's make a reasonable effort to support older versions of Elixir and OTP.","ref":"contributing.html#ground-rules","title":"Contributing - Ground Rules","type":"extras"},{"doc":"If you're interested in doing something specific, here are some guidelines: Security Issues If you find a security-related issue with this project, please refrain from opening a public issue and instead email the maintainer . Please include the name of the package in the subject line. Bugs and Blockers Please use GitHub Issues to report reproducible bugs. Feature Requests and Ideas Please use GitHub Discussions to share requests and ideas for improvements to the library. Implementing Changes If you've decided to take on the implementation of a new feature or fix, please open an issue or create a discussion post first to get feedback.","ref":"contributing.html#workflows","title":"Contributing - Workflows","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2023 CodeSandbox, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER IABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]